import {flatten,compact}from'lodash-es';/**
 * Runs f and returns a resolved promise with its value or a rejected promise with its exception,
 * regardless of whether it returns a promise or not.
 * @param f
 */
function tryCatchPromise(f) {
  try {
    return Promise.resolve(f());
  } catch (err) {
    return Promise.reject(err);
  }
}
/**
 * Reports whether value is a Promise.
 */
function isPromise(value) {
  return typeof value.then === 'function';
}
/**
 * Reports whether value is a {@link cdeops.Subscribable}.
 */
function isSubscribable(value) {
  return typeof value.subscribe === 'function';
}
/** Flattens and compacts the argument. If it is null or if the result is empty, it returns null. */
function flattenAndCompact(value) {
  if (value === null) {
    return null;
  }
  const merged = flatten(compact(value));
  return merged.length === 0 ? null : merged;
}
/** generate unique id for contributions */
function generateContributionId() {
  // always start with a letter (for DOM friendlyness)
  let idStr = String.fromCharCode(Math.floor(Math.random() * 25 + 65));
  do {
    // between numbers and characters (48 is 0 and 90 is Z (42-48 = 90)
    const asciCode = Math.floor(Math.random() * 42 + 48);
    if (asciCode < 58 || asciCode > 64) {
      // exclude all chars between : (58) and @ (64)
      idStr += String.fromCharCode(asciCode);
    }
  } while (idStr.length < 32);
  return idStr;
}export{flattenAndCompact,generateContributionId,isPromise,isSubscribable,tryCatchPromise};//# sourceMappingURL=util.js.map
